/*
 * counter.h
 *
 *  Created on: 25.03.2011
 *      Author: kostochkin
 */

#ifndef COUNTER_H_
#define COUNTER_H_

#define latch_down PORTC&=~(1<<2)
#define latch_up PORTC|=(1<<2)
#define sync_dac_low PORTC&=~(1<<0)
#define sync_dac_high PORTC|=(1<<0)
#define led_on PORTC&=~(1<<1)
#define led_off PORTC|=(1<<1)
#define led_flash PORTC^=(1<<1)
#define counter_reset_down PORTB&=~(1<<7)
#define counter_reset_up PORTB|=(1<<7)
#define SS_out ({DDRB|=(1<<2);				\
	            PORTB&=~(1<<2);})
#define SS_in DDRB&=~(1<<2)
#define SPI_on ({SS_out;		            \
                 SPCR=0x58;})
#define SPI_off ({SPCR=0x18;				\
	              SS_in;})
#define counter_low_bits (((PIND&0xC0)>>6)|((PINB&0x07)<<2)|(PIND&0x20))

#define counter_interrupt1(timer)					\
                            ({if (do_times>0) {		\
								timer;				\
								led_flash;			\
								do_times--;			\
							}						\
							else {					\
								counter_stop();		\
							}})

#define counter_interrupt2(timer)						\
							({timer;					\
							 high_counter_bits++;})

int high_counter_bits;
int do_times;

void counter_start(int value);
void counter_stop(void);

#define counter_eval ({								\
	switch (command) {								\
	case 'l':										\
		u_pch('1');									\
		set_dac_ref(value);							\
		break;										\
	case 'g':										\
		u_pch('1');									\
		counter_start(value);						\
		break;										\
	case 's':										\
		u_pch('1');									\
		counter_stop();								\
		break;										\
	default:										\
		u_pch('0');									\
		break;										\
	}})

void counter_read_eval (void);

#endif /* COUNTER_H_ */
