/*
 * init.c
 *
 *  Created on: 24.03.2011
 *      Author: kostochkin
 */
#include <avr/io.h>
#include <avr/interrupt.h>

void init_ports(void) {
	// init USB Tx and Rx, 1,2,6 bits of counter
	//	          RXD    TXD    nc     nc     nc     Q6     Q1     Q2
	DDRD = ((0 << 0) | (1 << 1) | (0 << 2) | (0 << 3) | (0 << 4) | (0 << 5)
			| (0 << 6) | (0 << 7));
	PORTD = 0x00;// | (1 << 5) | (1 << 6) | (1 << 7);
	// init SPI, 3-5 bits of counter, and counter reset
	//            Q3     Q4   Q5(SS)    MOSI   MISO   SCK     nc  COUNT_RST
	DDRB = ((0 << 0) | (0 << 1) | (0 << 2) | (1 << 3) | (0 << 4) | (1 << 5)
			| (0 << 6) | (1 << 7));
	PORTB = 0x00;// | (1 << 0) | (1 << 1) | (1 << 2);
	// init dac_latch(LATCH), SYNC (dac_cs), LED, Reset
	//        SYNC       LED       LATCH        nc       nc     nc   Reset   n/a
	DDRC = ((1 << 0) | (1 << 1) | (1 << 2) | (0 << 3) | (0 << 4) | (0 << 5)
			| (0 << 6) | (0 << 7));
	PORTC = 0x02;
}

void init_timer0(void) {
	TCCR0 = 0x00;
	TCNT0 = 0xB1;
	TCCR0 = 0x05;
}

void init_timer1(void) {

	TCCR1A = (0 << COM1A0) | (0 << COM1A1) | (0 << COM1B0) | (0 << COM1B1) | (0
			<< WGM10) | (0 << WGM11) | (0 << FOC1A) | (0 << FOC1B);
	TCCR1B = (0 << ICNC1) | (0 << ICES1) | (0 << WGM13) | (0 << WGM12) | (1
			<< CS12) | (1 << CS11) | (0 << CS10);
	TCNT1 = 0x0000;
	OCR1A = 0x0001;
	OCR1B = 0x0001;
}

void init_timers(void) {
	//	init_timer0();
	//	init_timer1();
	TIMSK |= (1 << TOIE0) | (1 << TOIE1);
}

void init_IO() {
	// init UART
	/* Set baud rate */
	UBRRH = 0x00; //set baud rate hi
	UBRRL = 0x01; //set baud rate lo
	/* Enable receiver and transmitter */
	UCSRB = (1 << RXEN) | (1 << TXEN);
	/* Set frame format: 8data, 2stop bit */
	UCSRC = (1 << URSEL) | (1 << USBS) | (3 << UCSZ0);
	SPCR = 0x18; //init, and disable spi
}

void init_device(void) {
	cli();
	OSCCAL = 0xAC; //clk calibration
	init_ports();
	init_IO();
	init_timers();
	sei();
}
